importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.rtm.sound);
importPackage(Packages.jp.ngt.ngtlib.io);

function onUpdate(su) {
    onUpdate_RSM2(su);

	var speed = su.getSpeed();
	var notch = su.getNotch();
	var sound_Wasabi = 'sound_wasabi';

    su.playSound(sound_Wasabi, '813gto.loop813', 1, 1);

    if (speed > 0 && speed < 10 && notch > 0) {
		su.playSound(sound_Wasabi, '813gto.813_Sq1', 1, 1, false);
	} else {
		su.stopSound(sound_Wasabi, '813gto.813_Sq1');
	}

}

//ここから下のプログラムをコピペしてonUpdate(su)にonUpdate_RSM2(su);を記述することで別のスクリプトに移植できます。
//##### 定数 #####

//音量フェードの時間の長さを設定します 単位:tick
var PowerFadeTime = 5;

//音量フェードの開始時間を遅らせます 単位:tick
var PowerFadeDelay = 0;

//トンネル走行音のフェードの時間の長さを設定します 単位:tick
var TunnelFadeTime = 10;

//##### データ #####
var SoundTrackData = [{"pitch":[[3,0.5],[8,1.8]],"volume":[[4,0],[5,0.5],[6,0.5],[8,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor1.5.ogg"},{"pitch":[[1,1],[7,1]],"volume":[[0,0],[1,1],[3,1],[8,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor1.ogg"},{"pitch":[[3,1],[9,1]],"volume":[[2,0],[6,1],[8.5,1],[8.7,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor2.ogg"},{"pitch":[[8,0.86],[11.6,1.1]],"volume":[[8.4,0],[8.6,1],[11,1],[11.1,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor3.ogg"},{"pitch":[[10.5,0.87],[16.5,1.28]],"volume":[[11,0],[11.1,1],[14.5,1],[16.5,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor4.ogg"},{"pitch":[[13.5,0.93],[20,1.27]],"volume":[[13.5,0],[16,1],[17.5,1],[20,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor5.ogg"},{"pitch":[[16,0.8],[26,1.25]],"volume":[[16,0],[18,1],[24,1],[25.1,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor6.ogg"},{"pitch":[[23.5,0.9],[32,1.3]],"volume":[[24,0],[24.1,1],[28,1],[30.1,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor7.ogg"},{"pitch":[[31,0.92],[40,1.17]],"volume":[[31,0],[33,1],[38,1],[38.3,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor8.5.ogg"},{"pitch":[[27,0.9],[36,1.25]],"volume":[[27,0],[29,1],[32,1],[34,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor8.ogg"},{"pitch":[[37.5,0.97],[50,1.25]],"volume":[[37.5,0],[37.8,1],[44,1],[50,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor9.ogg"},{"pitch":[[43,0.82],[58,1.15]],"volume":[[43,0],[48,1],[54,1],[58,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor10.ogg"},{"pitch":[[51,0.79],[73,1.26]],"volume":[[53,0],[57,1],[68,1],[72,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor11.ogg"},{"pitch":[[66,0.91],[85,1.23]],"volume":[[66,0],[71,1],[78,1],[85,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor12.ogg"},{"pitch":[[75,0.78],[100,1]],"volume":[[75,0],[83,1],[95,1],[100,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor13.ogg"},{"pitch":[[30,0.7],[100,1.1]],"volume":[[30,0],[55,0.8],[75,0.8],[95,0.8],[100,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"813_motor15.ogg"},{"pitch":[[90,0.85],[130,1.2]],"volume":[[94,0],[99,0.5],[130,0.5],[135,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"813_motor16.ogg"},{"pitch":[[80,0.6],[100,0.87],[110,0.92],[130,1.12]],"volume":[[86,0],[96,1],[130,1],[135,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motor17.ogg"},{"pitch":[[32.8,0.75],[50,1.25]],"volume":[[35.8,0],[38,1],[47,1],[50,0]],"isMute":false,"isNotchPower":false,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motorD1.ogg"},{"pitch":[[15,0.55],[39,1.25]],"volume":[[24.5,0],[25.7,1],[37,1],[39,0]],"isMute":false,"isNotchPower":false,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"813_motorD2.ogg"},{"pitch":[[13,0.7],[27,1.18]],"volume":[[16,0],[18,1],[25.8,1],[27,0]],"isMute":false,"isNotchPower":false,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motorD3.ogg"},{"pitch":[[7,0.7],[18,1.03]],"volume":[[9.5,0],[10.5,1],[16.5,1],[18.5,0]],"isMute":false,"isNotchPower":false,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motorD4.ogg"},{"pitch":[[0,1],[12,1]],"volume":[[0,0],[1,0.5],[10.5,0.5],[11.5,0]],"isMute":false,"isNotchPower":false,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"813_motorD5.ogg"},{"pitch":[[15,0.5],[30,1],[60,2]],"volume":[[0,0],[5,0.5],[35,0.5],[45,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"813_Run30km2.ogg"},{"pitch":[[30,0.5],[60,1],[90,1.5]],"volume":[[35,0],[45,0.5],[70,0.5],[80,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":false,"fileName":"813_Run60km2.ogg"},{"pitch":[[30,0.5],[60,1],[90,1.5]],"volume":[[35,0],[45,0.5],[75,0.5],[85,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":true,"fileName":"813_Run60kmT3.ogg"},{"pitch":[[60,0.5],[120,1],[180,1.5]],"volume":[[75,0],[85,0.5],[135,0.5],[145,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":false,"fileName":"813_Run120km2.ogg"},{"pitch":[[60,0.5],[120,1],[180,1.5]],"volume":[[75,0],[85,0.5],[135,0.5],[145,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":true,"fileName":"813_Run120kmT.ogg"},{"pitch":[[5,0.6],[10,0.9]],"volume":[[5,0],[6.5,0.1],[8.5,0.1],[9.5,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":false,"isFadeMixer":true,"isTunnelFade":null,"fileName":"f2000KO6.ogg"}];
var SoundEffectData = {};
var SoundData = {"813_motor1.5.ogg":["sound_wasabi","813gto.813_motor1.5"],"813_motor1.ogg":["sound_wasabi","813gto.813_motor1"],"813_motor2.ogg":["sound_wasabi","813gto.813_motor2"],"813_motor3.ogg":["sound_wasabi","813gto.813_motor3"],"813_motor4.ogg":["sound_wasabi","813gto.813_motor4"],"813_motor5.ogg":["sound_wasabi","813gto.813_motor5"],"813_motor6.ogg":["sound_wasabi","813gto.813_motor6"],"813_motor7.ogg":["sound_wasabi","813gto.813_motor7"],"813_motor8.5.ogg":["sound_wasabi","813gto.813_motor8.5"],"813_motor8.ogg":["sound_wasabi","813gto.813_motor8"],"813_motor9.ogg":["sound_wasabi","813gto.813_motor9"],"813_motor10.ogg":["sound_wasabi","813gto.813_motor10"],"813_motor11.ogg":["sound_wasabi","813gto.813_motor11"],"813_motor12.ogg":["sound_wasabi","813gto.813_motor12"],"813_motor13.ogg":["sound_wasabi","813gto.813_motor13"],"813_motor15.ogg":["sound_wasabi","813gto.813_motor15"],"813_motor16.ogg":["sound_wasabi","813gto.813_motor16"],"813_motor17.ogg":["sound_wasabi","813gto.813_motor17"],"813_motorD1.ogg":["sound_wasabi","813gto.813_motorD1"],"813_motorD2.ogg":["sound_wasabi","813gto.813_motorD2"],"813_motorD3.ogg":["sound_wasabi","813gto.813_motorD3"],"813_motorD4.ogg":["sound_wasabi","813gto.813_motorD4"],"813_motorD5.ogg":["sound_wasabi","813gto.813_motorD5"],"813_Run30km2.ogg":["sound_wasabi","813gto.813_Run30km2"],"813_Run60km2.ogg":["sound_wasabi","813gto.813_Run60km2"],"813_Run60kmT3.ogg":["sound_wasabi","813gto.813_Run60kmT3"],"813_Run120km2.ogg":["sound_wasabi","813gto.813_Run120km2"],"813_Run120kmT.ogg":["sound_wasabi","813gto.813_Run120kmT"],"f2000KO6.ogg":["sound_wasabi","813gto.f2000KO6"]};
//##### データ #####

//##### onUpdate #####
function onUpdate_RSM2(su) {
    var entity = su.getEntity();
    var dataMap = entity.getResourceState().getDataMap();
    var speed = su.getSpeed();
    var notch = su.getNotch();
    //powerFade
    var powerFade = dataMap.getInt("powerFade");
    var powerFadeDelayTime = dataMap.getInt("powerFadeDelayTime");
    if (notch === 0) powerFadeDelayTime = Math.min(powerFadeDelayTime + 1, PowerFadeDelay);
    else if (speed > 0) powerFadeDelayTime = Math.max(powerFadeDelayTime - 1, 0);
    if (notch > 0 && powerFadeDelayTime === 0) powerFade = Math.min(powerFade + 1, PowerFadeTime);
    else if (notch < 0 && powerFadeDelayTime === 0) powerFade = Math.max(powerFade - 1, -PowerFadeTime);
    else if (powerFadeDelayTime === PowerFadeDelay) powerFade += powerFade < 0 ? 1 : powerFade > 0 ? -1 : 0;
    dataMap.setInt("powerFadeDelayTime", powerFadeDelayTime, 0);
    dataMap.setInt("powerFade", powerFade, 0);
    powerFade = powerFade / PowerFadeTime;
    //tunnelFade
    var isTunnel = su.inTunnel();
    var tunnelFade = dataMap.getInt("tunnelFade");
    if (isTunnel) tunnelFade = Math.min(tunnelFade + 1, TunnelFadeTime);
    else tunnelFade = Math.max(tunnelFade - 1, 0);
    dataMap.setInt("tunnelFade", tunnelFade, 0);
    tunnelFade = tunnelFade / TunnelFadeTime;
    //SoundTrack
    SoundTrackData.forEach(function (trackData) {
        var soundName = trackData.fileName;
        var customPitch = 1;
        var customVolume = 1;
        /* 指定の音源でpitchとvolumeを乗算でカスタムすることができます
        例)
        if (soundName === "run_mo0.ogg") {//soundNameはRSM2での音源の表示名に対応します(拡張子付きファイル名)
            customPitch = 1.0;//ノッチに対して変化を加えるなど
            customVolume = 1.0;
        }
        */
        var sound = new SoundState(su, trackData);
        sound.play(speed, notch, powerFade, tunnelFade, customPitch, customVolume);
    });
    //SoundEffect
    var se = {};
    Object.keys(SoundEffectData).forEach(function (key) {
        var trackData = SoundEffectData[key];
        se[key] = new SoundState(su, trackData);
    });
    //Compressor
    var isCPActive = su.isComplessorActive();
    if (se["cpStart"]) se["cpStart"].playSE(isCPActive, false);
    if (se["cpLoop"]) se["cpLoop"].playSE(isCPActive, true);
    if (se["cpEnd"]) se["cpEnd"].playSE(!isCPActive, false);
    //Brake release
    var prevNotch = dataMap.getInt("prevNotch");
    dataMap.setInt("prevNotch", notch, 0);
    var isPlayBrakeH = prevNotch < notch && prevNotch === -8;
    var isPlayBrakeL = prevNotch <= 0 && prevNotch < notch && prevNotch < -1;
    var isPlayBrakeN = prevNotch < 0 && prevNotch < notch && notch >= 0;
    if (speed < 1) {
        if (se["brakeLow"]) se["brakeLow"].playSEOnce(isPlayBrakeL);
        if (se["brakeOff"]) se["brakeOff"].playSEOnce(isPlayBrakeN);
    }
    if (se["brakeHigh"]) se["brakeHigh"].playSEOnce(isPlayBrakeH);
}

//##### 関数 #####
var SoundState = function (su, trackData) {
    this.su = su;
    this.pitch = trackData.pitch || null;
    this.volume = trackData.volume || null;
    this.isMute = trackData.isMute || null;
    this.isNotchPower = trackData.isNotchPower || null;
    this.isNotchOff = trackData.isNotchOff || null;
    this.isNotchBrake = trackData.isNotchBrake || null;
    this.isFadeMixer = trackData.isFadeMixer || null;
    this.isTunnelFade = trackData.isTunnelFade; // null / true / false
    if (this.isTunnelFade === undefined) this.isTunnelFade = null;
    this.fileName = trackData.fileName;
    this.soundDmain = null;
    this.soundName = null;
    if (SoundData[this.fileName]) {
        this.soundDmain = SoundData[this.fileName][0];
        this.soundName = SoundData[this.fileName][1];
    }
};
SoundState.prototype = {
    getPitch: function (speed) {
        var pitch = interpolate(this.pitch, speed);
        return Math.min(Math.max(pitch, 0.5), 2.0);
    },
    getVolume: function (speed) {
        var volume = interpolate(this.volume, speed);
        if (speed > this.volume[this.volume.length - 1][0]) return 0;
        return Math.min(Math.max(volume, 0), 1.0);
    },
    getMixerVolume: function (notch, volumeFade, tunnelFade) {
        var volume = 1;
        var isNotchPower = this.isNotchPower;
        var isNotchOff = this.isNotchOff;
        var isNotchBrake = this.isNotchBrake;
        //Volume fade
        if (this.isFadeMixer && (isNotchOff !== isNotchPower || isNotchOff !== isNotchBrake)) {
            var notchFade = Number(volumeFade);
            var notchFadeF = Number(1 - Math.abs(notchFade));
            volume *= Math.max(
                Number(isNotchPower && notchFade > 0),
                Number(isNotchOff && notchFadeF > 0),
                Number(isNotchBrake && notchFade < 0)
            );
            volume *= isNotchOff ? Number(notchFadeF) : Number(Math.abs(notchFade));
        }
        else {
            volume *= Math.max(
                Number(isNotchPower && notch > 0),
                Number(isNotchOff && notch === 0),
                Number(isNotchBrake && notch < 0)
            );
        }
        //Tunnnel fade
        if (this.isTunnelFade !== null) {
            if (this.isTunnelFade === true) volume *= Number(tunnelFade);
            else volume *= Number(1 - tunnelFade);
        }
        volume *= Number(!this.isMute);
        return volume;
    },
    play: function (speed, notch, volumeFade, tunnelFade, customPitch, customVolume) {
        if (!this.soundDmain || !this.soundName) return;
        var pitch = this.getPitch(speed) * customPitch;
        var volume = this.getVolume(speed) * this.getMixerVolume(notch, volumeFade, tunnelFade) * customVolume;
        if (volume > 0) {
            this.su.playSound(this.soundDmain, this.soundName, volume, pitch, true);
        }
        else {
            this.su.stopSound(this.soundDmain, this.soundName);
        }
    },
    //条件分岐がtrueのときに再生する(falseで停止)
    playSE: function (condition, isLoop) {
        if (condition) this.su.playSound(this.soundDmain, this.soundName, 1, 1, isLoop);
        else this.su.stopSound(this.soundDmain, this.soundName);
    },
    //1tickだけ再生処理を実行するSEに使用する
    playSEOnce: function (condition) {
        if (condition) {
            this.su.stopSound(this.soundDmain, this.soundName);
            this.su.playSound(this.soundDmain, this.soundName, 1, 1, false);
        }
    }
};
function interpolate(valueList, speed) {
    if (valueList.length === 1) return 0;
    if (speed < valueList[0][0]) return valueList[0][1];
    for (var i = 0; i < valueList.length - 1; i++) {
        var currentSpeed = valueList[i][0];
        var currentValue = valueList[i][1];
        var nextSpeed = valueList[i + 1][0];
        var nextValue = valueList[i + 1][1];
        if (speed >= currentSpeed && speed <= nextSpeed) {
            var ratio = (speed - currentSpeed) / (nextSpeed - currentSpeed);
            return currentValue + (nextValue - currentValue) * ratio;
        }
    }
    return valueList[valueList.length - 1][1];
}